%{!?_httpd_mmn: %{expand: %%global _httpd_mmn %%(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)}}
Name:      mod_gnutls
Version:   0.7.2
Release:   1%{?dist}
Summary:   GnuTLS module for the Apache HTTP server
Group:     System Environment/Daemons
Packager : Django <django@mailserver.guru>
Distribution: CentOS 7
License:   ASL 2.0
URL:       http://modgnutls.sourceforge.net/
Source0:   http://modgnutls.sourceforge.net/downloads/%{name}-%{version}.tar.bz2
Source1:   mod_gnutls.conf
Source2:   00-gnutls.conf
Patch0:    mod_gnutls-0.6.0-apr_memcache_m4_dirty.patch
Patch1:    mod_gnutls-0.6.0-httpd24.patch
Patch2:    mod_gnutls-0.6.0-no-extra.patch
Patch3:    mod_gnutls-0.6.0-httpd-2.4.patch
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires: gnutls-devel, gnutls-utils, httpd-devel, apr-util-devel >= 1.3, libtool, autoconf, automake
Requires:  apr-util >= 1.3, gnutls-utils, httpd-mmn = %{_httpd_mmn}

%description
mod_gnutls uses the GnuTLS library to provide SSL 3.0, TLS 1.0 and TLS 1.1
encryption for Apache HTTPD.  It is similar to mod_ssl in purpose, but does
not use OpenSSL.  A primary benefit of using this module is the ability to
configure multiple SSL certificates for a single IP-address/port combination
(useful for securing virtual hosts).
    
Features
    * Support for SSL 3.0, TLS 1.0 and TLS 1.1.
    * Support for client certificates.
    * Support for RFC 5081 OpenPGP certificate authentication.
    * Support for Server Name Indication.
    * Distributed SSL Session Cache via Memcached
    * Local SSL Session Cache using DBM
    * Sets enviromental vars for scripts (compatible with mod_ssl vars)
    * Small and focused code base:
         Lines of code in mod_gnutls: 3,593
         Lines of code in mod_ssl: 15,324

%prep
%setup -q
#%patch0 -p1 -b .apr_memcache
#%patch1 -p1 -b .httpd24
#%patch2 -p1 -b .no-extra
#%patch3 -p1 -b .httpd24
cp %{SOURCE1} .

%build
rm -f configure
export APR_MEMCACHE_LIBS="`apu-1-config --link-ld`"
export APR_MEMCACHE_CFLAGS="`apu-1-config --includes`"
autoreconf -f -i

rm -rf autom4te.cache

%configure --disable-srp %{?_httpd_apxs:--with-apxs=%{_httpd_apxs}}
%{__make} %{?_smp_mflags}

%check
#%{__make} check

%install
rm -rf %{buildroot}
%{__install} -m 755 -D src/.libs/libmod_gnutls.so %{buildroot}%{_libdir}/httpd/modules/mod_gnutls.so
%{__install} -m 644 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_gnutls.conf
%{__install} -m 644 -D %{SOURCE2} %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/00-gnutls.conf

%clean
rm -rf %{buildroot}

%pre
rm -fr %{_localstatedir}/cache/mod_gnutls

%files
%defattr(-,root,root,-)
%doc CHANGELOG LICENSE NOTICE README 
%{_libdir}/httpd/modules/*.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_gnutls.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-gnutls.conf

%changelog
* Sun Nov 22 2015 Django <django@mailserver.guru> - 0.7.2-1
  Bugfix: Non-blocking reads in the input filter could lead to a busy
  wait in the gnutls_io_input_read function, causing high load on
  Keep-Alive connections waiting for data, until either more data
  could be received or the connection was closed. The fix is to pass
  EAGAIN/EINTR results up to the input filter so they can be handled
  properly.
- Close TLS session if the input filter receives EOF (mostly relevant
  for proper termination of proxy connections).
- Remove dependency on APR Memcache, which is replaced by the newer
  version included in the APR Utility Library (libaprutil).
- Remove dependency on bc. It was used for floating point arithmetic
  in the test suite, the calculations have been changed to use
  integers and pure bash code.

* Thu Oct 29 2015 Django <django@mailserver.guru> - 0.7.1-1
- Improved handling of PKCS #11 modules: mod_gnutls now loads either
  modules specified using GnuTLSP11Module, or the system defaults, but
  not both. Thanks to Nikos Mavrogiannopoulos for the report and
  initial patch!
- Initialize variables to safe defaults during client certificate
  verification. Certain error code paths did not set them, but they
  should never be hit due to config validation. This adds another line
  of defense.
- Enable C99 support via autoconf
- Test suite improvements. Most importantly, automake now handles
  environment setup without any external make calls. Rules to build
  the certificates are included from the old test makefile. Note that
  the dependency on GNU make is not new (the test makefile always used
  GNU make syntax), it just wasn't listed explicitly

* Mon Jul 13 2015 Django <django@mailserver.guru> - 0.7-1
- Security fix for TLS client authentication (CVE-2015-2091)
- Bug fixes that enable support for reverse proxy operation
- Various test suite improvements. Tests are configured through autoconf,
  so the test suite now works for builds without Monkeysphere support.
- Add support for TLS connections to back end servers when operating as a
  reverse proxy (X.509 authentication only at the moment).
- PKCS #11 support for server keys and certificates
- Use strict compiler arguments by default (-Wall -Werror -Wextra)
- Allow limiting the size of certificates exported as SSL_SERVER_CERT
  and SSL_CLIENT_CERT through the GnuTLSExportCertificates directive

* Sun Sep 28 2014 Django <django@mailserver.guru> - 0.6-2
 - extra configfile for module and configuration

* Fri Sep 19 2014 Django <django@mailserver.guru> - 0.6-1
 - Generating DH Params instead of using static ones.
 - Now considering ServerAlias Directives.
 - Major Legacy Code Cleanup.
 - html and pdf and manual documentation generated from markdown sources
 - support monkeysphere validation agent (MSVA) client-certificate verification
 - wider test suite
 - GnuTLSExportCertificates off by default

* Fri Sep 12 2014 Django <django@mailserver.guru> - 0.5.10-1
- Initial build

